function shortcutsPrefInit() {
  var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                                .getService(Components.interfaces.nsIExtensionManager);
  var keyconfigExtension = extensionManager.getItemForID("keyconfig@dorando");
  var shortcutsPanelDeck = document.getElementById("shortcutsPanelDeck");

  // If it fails, try with old id
  if ((!keyconfigExtension) || (keyconfigExtension.type == 0)) {
    keyconfigExtension = extensionManager.getItemForID("{c8500d90-d72d-11d9-8cd5-0800200c9a66}");
  }

  if ((!keyconfigExtension) || (keyconfigExtension.type == 0)) {
    shortcutsPanelDeck.setAttribute("selectedIndex", 0);
  } else {
    var xmlDoc = document.implementation.createDocument("", "keyconfig", null);
    xmlDoc.async = false;
    try {
      xmlDoc.load("chrome://keyconfig/content/");
      if (xmlDoc.documentElement) {
        // Enabled
        shortcutsPanelDeck.setAttribute("selectedIndex", 2);
      } else {
        // Disabled
        shortcutsPanelDeck.setAttribute("selectedIndex", 1);
      }
    } catch (e) {
      // Exception while loading, so it's disabled
        shortcutsPanelDeck.setAttribute("selectedIndex", 1);
    }
  }
}

function callKeyConfig() {
  // Target all windows
  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
  var windowIter = wm.getEnumerator('navigator:browser');
  var keyconfigInvoked = false;

  while (windowIter.hasMoreElements() && !keyconfigInvoked) {
    var currentWindow = windowIter.getNext();
    try {
      currentWindow.openDialog('chrome://keyconfig/content/', 'keyconfig', 'resizable');
      keyconfigInvoked = true;
    } catch (e) { }
  }
  
  if (!keyconfigInvoked) {
    // TODO: Show error message?
  }
}

function openURL(aURL, event)
{
   var linkTarget, loadInBackground;
      try {
            linkTarget =    gPref.getIntPref("browser.link.open_newwindow");
      loadInBackground = gPref.getBoolPref("browser.tabs.loadInBackground");
      }
      catch (e) {
      linkTarget = 1;
      loadInBackground = true;
   }

   if (aURL == null) aURL = "about:blank";
   
   var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator);

   // check for an existing window and focus it; it's not application modal
   var anyWindow = windowManager.getMostRecentWindow("navigator:browser");

   if (!anyWindow) {
      openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", aURL, null, null, null);
      if (event && event instanceof Event) {
         event.preventDefault();
         event.preventBubble();
         event.preventCapture();
         event.stopPropagation();
      }
      return true;
   }

   anyWindow.open(aURL, "_blank");

   if (event && event instanceof Event) {
      event.preventDefault();
      event.preventBubble();
      event.preventCapture();
      event.stopPropagation();
   }
   return true;
}