function showShowcaseAllWindows(event) {
  if ((!event) || (event.type != "command")) {
      showShowcase(true, false);
  } else if (event.shiftKey) {
    if (event.ctrlKey) {
      showShowcase(false, true);
    } else {
      showShowcase(false, false);
    }
  } else {
    if (event.ctrlKey) {
      showShowcase(true, true);
    } else {
      showShowcase(true, false);
    }
  }
}

function showShowcaseThisWindow(event) {
  if ((!event) || (event.type != "command")) {
      showShowcase(false, false);
  } else if (event.shiftKey) {
    if (event.ctrlKey) {
      showShowcase(true, true);
    } else {
      showShowcase(true, false);
    }
  } else {
    if (event.ctrlKey) {
      showShowcase(false, true);
    } else {
      showShowcase(false, false);
    }
  }
}

function showShowcaseTabAllWindows(event) {
  if ((!event) || (event.type != "command")) {
      showShowcase(true, true);
  } else if (event.shiftKey) {
    if (event.ctrlKey) {
      showShowcase(false, false);
    } else {
      showShowcase(false, true);
    }
  } else {
    if (event.ctrlKey) {
      showShowcase(true, false);
    } else {
      showShowcase(true, true);
    }
  }
}

function showShowcaseTabThisWindow(event) {
  if ((!event) || (event.type != "command")) {
      showShowcase(false, true);
  } else if (event.shiftKey) {
    if (event.ctrlKey) {
      showShowcase(true, false);
    } else {
      showShowcase(true, true);
    }
  } else {
    if (event.ctrlKey) {
      showShowcase(false, false);
    } else {
      showShowcase(false, true);
    }
  }
}

function showShowcase(allWindows, embedTab) {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
      prefs = prefs.getBranch("extensions.showcase.");

      // First close the window so we can keep the "last position" and "last size" values
      if (!embedTab) {
        var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
        var windowIter = wm.getEnumerator('extension:showcase');
        if (windowIter.hasMoreElements()) {
          do {
            var currentWindow = windowIter.getNext();
            currentWindow.closeWindow();
          } while (windowIter.hasMoreElements());
        }
      }

	// Check if we've to embed showcase in a tab
	if (embedTab) {
        var showcaseTab = getBrowser().addTab("chrome://showcase/content/showcase.xul?global=" + allWindows);
        getBrowser().selectedTab = showcaseTab;
        return;
	}

      var windowHeight, windowWidth;
      var createWindowString = "chrome";
      
      var showcaseWidthType = prefs.getIntPref("windowWidth");
      var widthPercentage = parseFloat(prefs.getCharPref("windowWidthPercentage"));
      var widthModifier = prefs.getIntPref("windowWidthModifier");

      createWindowString += ",width=";

      if (showcaseWidthType == 0) {
        windowWidth = Math.floor(window.outerWidth * widthPercentage / 100 + widthModifier);
        createWindowString += windowWidth;
      } else if (showcaseWidthType == 1) {
        windowWidth = Math.floor(window.screen.availWidth * widthPercentage / 100 + widthModifier);
        createWindowString += windowWidth;
      } else { // if (showcaseWidthType == 2)
        windowWidth = prefs.getIntPref("windowLastWidth");
        createWindowString += windowWidth;
        if (windowWidth < 1) {
          windowWidth = 300;
        }
      }

      var showcaseHeightType = prefs.getIntPref("windowHeight");
      var heightPercentage = parseFloat(prefs.getCharPref("windowHeightPercentage"));
      var heightModifier = prefs.getIntPref("windowHeightModifier");

      createWindowString += ",height=";

      if (showcaseHeightType == 0) {
        windowHeight = Math.floor(window.outerHeight * heightPercentage / 100 + heightModifier);
        createWindowString += windowHeight;
      } else if (showcaseHeightType == 1) {
        windowHeight = Math.floor(window.screen.availHeight * heightPercentage / 100 + heightModifier);
        createWindowString += windowHeight;
      } else { // if (showcaseHeightType == 2)
        windowHeight = prefs.getIntPref("windowLastHeight");
        if (windowHeight < 1) {
          windowHeight = 300;
        }
        createWindowString += windowHeight;
      }
      
      if (prefs.getBoolPref("windowAttributeDialog")) {
        createWindowString += ",dialog=yes";
      } else {
        createWindowString += ",dialog=no";
      }

      if (prefs.getBoolPref("windowAttributeModal")) {
        createWindowString += ",modal=yes";
      }

      if (prefs.getBoolPref("windowAttributeAlwaysRaised")) {
        createWindowString += ",alwaysRaised";
      }

      var showcasePosition = prefs.getIntPref("windowPosition");
      if (showcasePosition == 0) {
        // Center on invoking window
        createWindowString += ",left=" + 
         Math.floor(window.screenX + window.outerWidth / 2 - windowWidth / 2) +
         ",top=" +
         Math.floor(window.screenY + window.outerHeight / 2 - windowHeight / 2);
      } else if (showcasePosition == 1) {
        // Center on current screen
        createWindowString += ",centerscreen=yes";
      } else if (showcasePosition == 2) {
        // Remember last position
        createWindowString += ",left=" + 
         prefs.getIntPref("windowLastX") +
         ",top=" +
         prefs.getIntPref("windowLastY");
      } else { // if (showcasePosition == 3) {
        // Remember last position relative to invoking window
        createWindowString += ",left=" + 
         (window.screenX + prefs.getIntPref("windowLastRelativeX")) +
         ",top=" +
         (window.screenY + prefs.getIntPref("windowLastRelativeY"));
      }

      // Add "normal" parameters
      createWindowString += ",close=yes,resizable=yes";
      
      var showcaseURL = "chrome://showcase/content/showcase.xul?global=" + allWindows;
      var showcaseWindow = window.openDialog(showcaseURL,
		"showcaseDialog", createWindowString, window);

      // Try to focus on new window (will fail if window is modal, but that's not an issue)
      try {
        showcaseWindow.focus();
      } catch (e) {}
}

